
require 'taeval/cli'

require "taeval/version"
require 'taeval/runner_wrapper'
require 'taeval/config_manager'
require 'taeval/executor'

module Taeval

  def self.eval(config_file, &block)
    config_manager = ConfigManager.create(config_file)
    reporter = config_manager.reporter
    config   = config_manager.config
    output   = config_manager.output
    executor = Executor.new(config, output, reporter)
 
    runner   = RunnerWrapper.new(executor)
    runner.instance_eval &block
    
    executor.run
    reporter.save
  rescue StandardError => e
     puts "\e[31mError:\e[0m #{ e.message }"
  end

end
