require 'yaml'

require 'taeval/reporter'
require 'taeval/output'
require 'taeval/file_helper'

module Taeval
  class ConfigManager
    extend Taeval::FileHelper

    attr_reader :config, :output, :reporter
   
    class << self
      
      def create(config_file)
        path = path_of(config_file) 
        conf = YAML.load(File.read(path))
        flatten_include!(conf)
        ConfigManager.new(conf, Output.new(conf), Reporter.new(conf))
      end
    
    end

    private

    def initialize(config, output, reporter)
      @config   = config
      @reporter = reporter
      @output   = output
    end

  end
end
