
require 'taeval/runner_factory'

module Taeval
  class Executor 
    include Taeval::FileHelper

    def initialize(config, output, reporter)
      @config   = config
      @reporter = reporter
      @output   = output
      @runners  = {} 
    end

    def add(runner)
      conf = @config[runner.to_s]
      ['solution', 'report', 'verbose'].each { |key| conf[key] = @config[key] }
      @runners[runner] = RunnerFactory.create(runner, conf, @output, @reporter)
    end

    def run
      @runners.each_pair { |_, runner| runner.run }
    end

    def save
      @reporter.save
    end
  end
end
