
require 'taeval/git_checkout/github_repo'
require 'taeval/git_checkout/gitlab_repo'
require 'taeval/git_checkout/bitbucket_repo'

module Taeval
  module GitCheckout
    class RepoFactory

      def self.create(config, output, reporter)
        case config[:host].to_sym
        when :github
          Taeval::GitCheckout::GithubRepo.new(config, output, reporter)
        when :gitlab
          Taeval::GitCheckout::GitlabRepo.new(config, output, reporter)
        when :bitbucket
          Taeval::GitCheckout::BitbucketRepo.new(config, output, reporter)
        else
          reporter.add(repo: config[:id], runner: :git_checkout, msg: "#{config[:host]} is not supported")
        end
      end

    end
  end
end
