
require 'open3'
require 'json'

require 'taeval/git_checkout/config'
require 'taeval/git_checkout/repo_factory'

module Taeval
  module GitCheckout 
    class Runner
      
      def initialize(config, output, reporter)
        @config   = Config.new(config)
        @output   = output
        @reporter = reporter
      end

      def run
        @config.source.each do |source|
          repo = RepoFactory.create(
                                {host:     source[:host],
                                  id:       source[:id],
                                  user:     source[:user],
                                  repo:     source[:repo],
                                  prefix:   @config.prefix,
                                  branch:   @config.branch,
                                  token:    @config.tokens[source[:host]],
                                  attr:     @config.attr,
                                  solution: @config.solution},
                                  @output,
                                  @reporter
                                )
          repo.validate
          repo.clone
        end
      end
   
    end
  end
end
