
module Taeval
  module Plagium
    class Config
      include Taeval::FileHelper
      
      attr_reader :solutions, :id, :language, :max_matches, :show_num_matches, :comment, :output, :reject

      def initialize(conf_h)
        @id               = conf_h.fetch('id', '')
        @language         = conf_h.fetch('language', 'ascii')
        @max_matches      = conf_h.fetch('max_matches', 10)
        @show_num_matches = conf_h.fetch('show_num_matches', 250)
        @comment          = conf_h.fetch('comment', '')
        
        output_path       = conf_h.fetch('output', '')
        @output           = File.new(path_of(output_path), 'w') 

        @reject           = conf_h.fetch('reject', '') 
        @solutions        = path_of(conf_h.dig('solution', 'path'))
        if !File.exist?(@solutions)
          raise "Plagium: Path of input solutions not exists: #{@solutions}"
        end

      end
    end
  end
end
