
require 'taeval/git_checkout/runner'
require 'taeval/plagium/runner'
require 'taeval/static_code_analysis/runner'
require 'taeval/unittest/runner'
require 'taeval/hadolint/runner'

module Taeval
  class RunnerFactory
  
    def self.create(runner, *config, output, reporter)
      case runner
      when :git_checkout
        Taeval::GitCheckout::Runner.new(*config, output, reporter)
      when :plagium
          Taeval::Plagium::Runner.new(*config, output, reporter)
      #when :static_code_analysis
      #  Taeval::Runners::StaticCodeAnalysis.new(*config)
      when :unittest
        Taeval::Unittest::Runner.new(*config, output, reporter)
      when :hadolint
        Taeval::Hadolint::Runner.new(*config, output, reporter)
      else
        raise "Runner does not exist. (#{ runner })"
      end
    end

  end
end
